clear all;close all;clc %#ok<CLALL>
foldername='C:\Users\Localadmin\Downloads\Tables\';
foldername_tables = 'O:\Dropbox\Dropbox\Matlab-speed from dashcams\Tables';
extension_save = '_table';
load('Numbers4.mat');
Numbers=Numbers4;
for i=1:10
    Numbers{i}=Numbers{i}/max(max(Numbers4{i}))*255;
end
STO=0; % store reference numbers
for i=1:10;Numbers3{i}=zeros(31,23);end
Locations.date=[    15    45    20    42  % y top, y bottom, x left, x right
    15    45    42    64
    15    45    86   108
    15    45   108   130
    15    45   152   174
    15    45   174   196
    15    45   196   218
    15    45   218   240];

Locations.time=[    15    45   268   290
    15    45   292   314
    15    45   327   349
    15    45   349   371
    15    45   384   406
    15    45   406   428];

Locations.kmh=[115   145   537   559
    115   145   559   581];

Locations.gps=[115   145   51
    115   145   74
    115   145 97
    115   145 120
    115   145 143
    115   145 166
    115   145 189
    115   145 212
    115   145 265
    115   145 289
    115   145 312
    115   145 335
    115   145 358
    115   145 381
    115   145 405
    115   145 428
    115   145 451];
Locations.gps(:,4)=Locations.gps(:,3)+22;

files=dir([foldername '*.mov']);
for video_nr=1:length(files);
    count=0;
    filename=files(video_nr).name;
    vidObj=VideoReader(fullfile(foldername, filename)); %#ok<TNMLP>
    while hasFrame(vidObj) && count<=vidObj.Duration
        vidObj.CurrentTime = count;
        Image = readFrame(vidObj);
        count = count+1;
        disp(count)
        Image_BW = zeros(size(Image,1),size(Image,2));
        Image_BW(Image(:,:,1)<=80 & Image(:,:,2)>=150 )=1;
        
        temp_date=NaN(8,1);
        for n=1:8 % Loop over the 8 digits for date
            fit_tot=NaN(10,1);
            for i=1:10
                NC = normxcorr2(Image_BW(Locations.date(n,1):Locations.date(n,2),Locations.date(n,3):Locations.date(n,4)),Numbers{i});
                fit_tot(i) = max(NC(31,:));
            end
            [~,temp_date(n)] = max(fit_tot);temp_date(n)=temp_date(n)-1;
            Numbers3{temp_date(n)+1}=Numbers3{temp_date(n)+1}+ Image_BW(Locations.date(n,1):Locations.date(n,2),Locations.date(n,3):Locations.date(n,4));
        end
        
        temp_time=NaN(6,1);
        for n=1:6 % Loop over the 6 digits for time
            for i=1:10
                NC = normxcorr2(Image_BW(Locations.time(n,1):Locations.time(n,2),Locations.time(n,3):Locations.time(n,4)),Numbers{i});
                fit_tot(i) = max(NC(31,:));
            end
            if STO==1 % flag
                if count<10 % tested for video 20170222_123033.MOV
                    Numbers2{count+1}=Image_BW(Locations.time(n,1):Locations.time(n,2),Locations.time(n,3):Locations.time(n,4)); % 1-9
                end
                if count==10
                    Numbers2{1}=Image_BW(Locations.time(n,1):Locations.time(n,2),Locations.time(n,3):Locations.time(n,4)); % 0
                    save('Numbers2.mat','Numbers2')
                end
            end
            [~,temp_time(n)] = max(fit_tot);temp_time(n)=temp_time(n)-1;
            Numbers3{temp_time(n)+1}=Numbers3{temp_time(n)+1}+ Image_BW(Locations.time(n,1):Locations.time(n,2),Locations.time(n,3):Locations.time(n,4));
        end
        table(video_nr).date(count)=datenum(temp_date(5)*1000+temp_date(6)*100+temp_date(7)*10 + temp_date(8),temp_date(3)*10 + temp_date(4),temp_date(1)*10+temp_date(2),temp_time(1)*10+temp_time(2),temp_time(3)*10 + temp_time(4),temp_time(5)*10 + temp_time(6));
        try
            temp_gps=NaN(17,1);
            for n=1:17 % Loop over the 17 digits for gps
                for i=1:10
                    NC=normxcorr2(Image_BW(Locations.gps(n,1):Locations.gps(n,2),Locations.gps(n,3):Locations.gps(n,4)),Numbers{i});
                    fit_tot(i) = max(NC(31,:));
                end
                [~,temp_gps(n)] = max(fit_tot);temp_gps(n)=temp_gps(n)-1;
                Numbers3{temp_gps(n)+1}=Numbers3{temp_gps(n)+1}+ Image_BW(Locations.gps(n,1):Locations.gps(n,2),Locations.gps(n,3):Locations.gps(n,4));
            end
            table(video_nr).lat(count)=sum(temp_gps(1:8)'.*10.^[1:-1:-6]);
            table(video_nr).long(count)=sum(temp_gps(9:17)'.*10.^[2:-1:-6]);
        catch
            table(video_nr).lat(count)=NaN;
            table(video_nr).long(count)=NaN;
            
        end
        try
            temp_kph=NaN(2,1);
            for n=1:2
                for i=1:10
                    NC=normxcorr2(Image_BW(Locations.kmh(n,1):Locations.kmh(n,2),Locations.kmh(n,3):Locations.kmh(n,4)),Numbers{i});
                    fit_tot(i) = max(NC(31,:));
                end
                [~,temp_kph(n)] = max(fit_tot);temp_kph(n)=temp_kph(n)-1;
                Numbers3{temp_kph(n)+1}=Numbers3{temp_kph(n)+1}+ Image_BW(Locations.kmh(n,1):Locations.kmh(n,2),Locations.kmh(n,3):Locations.kmh(n,4));
            end
            table(video_nr).kmh(count) = temp_kph(1)*10+temp_kph(2);
        catch error
            table(video_nr).kmh(count)=NaN;
        end
        
        table(video_nr).frametime(count) = vidObj.CurrentTime;
        table(video_nr).filename = filename;
        
        imagesc(Image)
        axis([0 800 0 200])
        title(['date = ',datestr(table(video_nr).date(count)), ', speed = ', num2str(table(video_nr).kmh(count)), ', lat = ', sprintf('%f',table(video_nr).lat(count)) ', long = ', sprintf('%f',table(video_nr).long(count))]);
        pause(0.01)
        if count==42
            pause
        end
    end
    save(fullfile(foldername_tables, [filename(1:end-4), extension_save, '.mat']),'table');
end